/* ---------------------------------------------------------------------------
 * [z-11 project]
 * (c) Copyright Malekith (malekith@topnet.pl and http://malekith.topnet.pl)
 * For info about copying see file copying.z11.
 *
 * file "draw.s", created on 13/06/99.
 * descr : 3d gfx draw functions - two little, but good optimized funcs.
 *
 * don't think that this code has been producted by any compiler...
 * none compiler nowadays will produce such a code
 *
 * C equivalnts are given. so if you'd like to port this to another CPU, see at them
 * not the asm code ... (but don't put them exactly in your code, make some 
 * "register" local variables and so on. And of course don't forget turn on 
 * the optimizing!
 *
 * But if you are wrtting asm version for your CPU, then look
 * as I did that, but remember, that other CPU's have other timing tables, so
 * the best method could differ (especialy on mc68k you can put all into regs ...
 * intel have only 2 address regs, you have 7 so use it!) another thing is,
 * that I don't think this code is best for 486+... and i'm sure that this 
 * code isn't best for 386, it'd be faster to put everything in tables, but 
 * who has 386 nowaday ?) 
 * (if you do I'm sorry, I had too about 6 months ago and I would have been 
 * angry if read that, but ... )
 *
 * arguments to this funcs are passed in global variables. nobady cares about 
 * them after execution of routine. so even if C func has changed some of them 
 * your asm func don't have to do that, if it'll take additional time to set 
 * them to proper values after execution
 *
 * btw: after changing this routines to asm I havn't seen any diffrence in 
 * speed ...
 * (before I compiled them with -O3)
 * think that's 'cause my slow SVGA - the most of time is taken by 
 * RenderBuffer() routine.
 * another thing which proves that, is : modex is almost as fast as 13h (Allegro 
 * changes chunky to planar in memory, and then sends them into vram, which 
 * takes most of time) and changing Allegro own blit() (which must care about 
 * cooridinates, clipping and so on) routine to "rep movsl" didn't help making 
 * code faster. diffinetly I have to buy PCI/AGP card...
 *
 * wonna thnx people from AT&T creating intel opcodes which can be understand 
 * by normal mortal ... (especialy is he was coding mc68k in the past)
 * i'm not shaman to think in categories of offsets and "byte ptr"s (still dont 
 * know what is it ;)
 *
 * if you are rewriting this in C -- remember to change varible's names --
 * you probably see that they havn't go leading '_'in names, arn't you ?
 * so look at 3dGfx.cc file - there are definition of some variables with
 * asm("name") keyword.
 *
 * ------------------------------------------------------------------------- */

/* -------------------------------------------------------------------------
 void doVDraw()
 all rewriten in assembly, but it's almost exact eqivalent to C func:
 extern "C" void doVDraw() {
   do {
     *vram = light[text[scale_index>>8]]
     vram += sw;
     scale_index+=scale_step;
   } while(n-->0);
 }
 almost, because gloabl variable n isn't changed, since counter is stored in 
 register
 --------------------------------------------------------------------------- */

 .text
        .p2align 2
.globl _doVDraw
_doVDraw:
        .align 2,0x90
  pushl %esi
  pushl %edi
  pushl %ebx
  movl light,%edi
  movl text,%esi
  movl scale_index,%ebx
  movl vram,%ecx
  movl n,%edx
/ do {
L2:
/  *vram        = light[text[scale_index>>8]];
  movl %ebx,%eax
/ %eax = scale_index>>8
  sarl $8,%eax
/ %eax = text[scale_index>>8]
  movb (%esi,%eax),%eax
  andl $0xff,%eax
/ *vram = light[text[scale_index>>8]]
  movb (%edi,%eax),%al
  movb %al,(%ecx)
  addl sw,%ecx        /* vram += sw */
  addl scale_step,%ebx   /* scale_index+=scale_step */
/ while(n-->0);
  decl %edx
  testl %edx,%edx
  jg L2

  popl  %ebx
  popl  %edi
  popl  %esi
  ret

/* ------------------------------------------------------------------------------------
 void doSpriteVDraw()
 all rewriten in assembly, but it's almost exact eqivalent to C func:
 extern "C" void doSpriteVDraw() {
   do {
     if(light[text[scale_index>>8]])
       *vram = light[text[scale_index>>8]];
     vram += sw;
     scale_index+=scale_step;
   } while(n-->0);
 }
 almost, because gloabl variable n isn't changed, since counter is stored in register
 ------------------------------------------------------------------------------------ */
        .p2align 2
.globl _doSpriteVDraw
_doSpriteVDraw:
        .align 2,0x90
  pushl %esi
  pushl %edi
  pushl %ebx
  movl light,%edi
  movl text,%esi
  movl scale_index,%ebx
  movl vram,%ecx
  movl n,%edx
/ do {
L3:
/  *vram        = light[text[scale_index>>8]];
  movl %ebx,%eax
/ %eax = scale_index>>8
  sarl $8,%eax
/ %eax = text[scale_index>>8]
  movb (%esi,%eax),%eax
  andl $0xff,%eax
  jz skip0
/ *vram = light[text[scale_index>>8]]
  movb (%edi,%eax),%al
  movb %al,(%ecx)
skip0:
  addl sw,%ecx        /* vram += sw */
  addl scale_step,%ebx   /* scale_index+=scale_step */
/ while(n-->0);
  decl %edx
  testl %edx,%edx
  jg L3

  popl  %ebx
  popl  %edi
  popl  %esi
  ret
/* ------------------------------------------------------------------------------------
 void doHDraw()
 all rewriten in assembly, but it's exact eqivalent to C func:
 extern "C" void doHDraw() {
   do {
     *vram++=light[text[((x>>16)&floorMaskDown)+((y>>(16-floorFP))&(floorMaskDown<<floorFP))]];
     x+=vx;
     y+=vy;
   } while(n-->0);
 }
 ------------------------------------------------------------------------------------ */

/ remember to change this if changing 3dGfx.h file !!!
 floorFP=9
 floorMaskDown=(1<<floorFP)-1

        .p2align 2
.globl _doHDraw
_doHDraw:
        .align 2,0x90
  pushl %esi
  pushl %edi
  pushl %ebx
  movl light,%edi
  movl text,%esi
  movl x,%ebx
  movl y,%ecx

L7:
  movl %ecx,%eax
  sarl $(16-floorFP),%eax
  andl $(floorMaskDown<<floorFP),%eax
  movl %ebx,%edx
  sarl $16,%edx
  andl $floorMaskDown,%edx
  addl %edx,%eax
  movb (%esi,%eax),%al
  andl $0xff,%eax
  movb (%edi,%eax),%al
  movl vram,%edx
  incl vram
  movb %al,(%edx)
/ x+=vx;
  addl vx,%ebx
/ y+=vy;
  addl vy,%ecx
/ while(n-->0)
  movl n,%eax
  decl n
  testl %eax,%eax
  jg L7
/ }
  popl  %ebx
  popl  %edi
  popl  %esi
  ret




