// 15/07/99

#ifndef EventsH
#define EventsH

class Object;

class Event {
  public:
    Object * sender;
    Event(Object * s) : sender(s) { }
    virtual ~Event() { }
    virtual XStr className() { return "Event"; }
};

class Object {
  public:
    virtual XStr className() { return "Object"; }
    virtual void handleEvent(Event * e) { delete e; }
    virtual ~Object() { }
};

class EvMove : public Event {
  public:
    enum turn_t { turnLeft, turnNone, turnRight };
    enum dir_t  { dirNone, dirForward, dirBackward, dirLeft, dirRight };
    dir_t dir; 
    turn_t turn; 
    
    EvMove(Object * s, dir_t d=dirNone, turn_t t=turnNone) 
        : Event(s), dir(d), turn(t) { }
    virtual XStr className() { return "EvMove"; }
};

class EvCommand : public Event {
  public:
    XStr cmd;
    
    EvCommand(Object * s, XStr xcmd) 
        : Event(s), cmd(xcmd) { }
    virtual XStr className() { return "EvCommand"; }
};

#endif // EventsH


