// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "main.cc", created on 10/06/99.
 * descr : main file & debug stuff
 * it was worlock.c file in the far past ... almost nothing's the same ...
 */
// ----------------------------------------------------------------------------------


#include "z11.h"
#include "WorldMap.h"
#include "3dGfx.h"
#include "Player.h"
#include "Input.h"
#include "Term.h"

#include <vga.h>
#include "EvKbd.h"

FILEINFO(main);

// ----------------------------------------------------------------------------------
extern void init();
extern void cleanUp();
extern void Ray_Caster(int x,int y,float view_angle);
extern void RenderBuffer();
// ----------------------------------------------------------------------------------
int frame=1;
int debugArg=0;
int argc;
char ** argv;
// ----------------------------------------------------------------------------------
extern void growWindow(int dx, int dy);
bool gameRun=true;
void testNonMotionKeys();
// ----------------------------------------------------------------------------------
void mainLoop() {
  timer_t last=timer();
  while(gameRun) {
    kbd->update(); 

    int time=timer()-last;
    last=timer();
	
    player->think(time);
        // here other_monsters->think()
    player->move(time);
        // here other_monsters->move()

    Ray_Caster((int)player->x,(int)player->y,player->angle);
    map.drawMap();
    player->updateGfx(); // gun!
    RenderBuffer();
    frame++;
  }
}
// ----------------------------------------------------------------------------------
int main(int margc, char ** margv)
{
  argc=margc; argv=margv;
  try {
    init();
    /*
    vga_setmode(TEXT);
    kbd->eventWaitModeOn();
    do {
      kbd->waitForEvent();
      Event * e = kbd->getEvent();
      assert(e->className()=="EvKbd");
      EvKbd * ev = (EvKbd*)e;
      if(ev->isSpecial) printf("<%d>",ev->data);
      else printf("%c",(char)ev->data);
      fflush(stdout);
    } while(gameRun);
    kbd->eventWaitModeOff();
    vga_setmode(G320x200x256);
    */
    
    try {
      mainLoop();
    } catch(ERecoverable & e) {
      if(debug) 
        { fprintf(debugFile(),"recov: %s\n",e.format().chars()); fflush(dbg); }
        // maybe some warning to player ?
    } 
    
    cleanUp();
    return 0;
  } catch(EBase & e) {
    handleException(e);
  } catch(...) {
    EBase e("Unknown exception!");
    handleException(e);
  }
} // end main
// ----------------------------------------------------------------------------------



