//17/07/99

#include <math.h>

#include "z11.h"
#include "WorldMap.h"
#include "Player.h"
#include "3dGfx.h"

bool needRedraw,drawMap=true,compass=true;

// ------------------------------------------------------------------------------
void doDrawMap(MetaBmp & bmp) {
  if(drawMap) {
    int sx=(screen.w>>8)>?1, sy=(screen.h>>8)>?1;
    Bmp(map.picture,map.w*sx,map.h*sy).putS(bmp,0,bmp.h-map.h*sy-1);
  }
}
// ------------------------------------------------------------------------------
void doCompass(MetaBmp & bmp) {
  if(!compass) return;
  int x=screen.w/20, y=screen.h/14;
  float a=-player->angle*M_PI/180+M_PI;
  int c=color(0x000000);
  static int x1=0,y1=0,x2=0,y2=0,x3=0,y3=0;
  bmp.draw(x1,y1,x2,y2,c);
  bmp.draw(x2,y2,x3,y3,c);
  bmp.draw(x3,y3,x1,y1,c);
  x1=(int)(x-x*cos(a)),      y1=(int)(y-y*sin(a)),
  x2=(int)(x-x*cos(a-3)),    y2=(int)(y-y*sin(a-3)),
  x3=(int)(x-x*cos(a-3.28)), y3=(int)(y-y*sin(a-3.28));
  c=color(0xffffff);
  bmp.draw(x1,y1,x2,y2,c);
  bmp.draw(x2,y2,x3,y3,c);
  bmp.draw(x3,y3,x1,y1,c);
  bmp.plot(x,y,c);
}
// ------------------------------------------------------------------------------
extern Bmp background;
void RenderBuffer() {
  if(needRedraw) background.put(0,0);
  needRedraw=false;
  bool fullScreen=false;
  if(doubleBuffer.h==screen.h && doubleBuffer.w<screen.w) {
    doDrawMap(doubleBuffer);
    doCompass(doubleBuffer);
    fullScreen=true;
  }
  screen.vsync();
  doubleBuffer.put((screen.w-doubleBuffer.w)/2,(screen.h-doubleBuffer.h)/2);
  if(!fullScreen) {
    doDrawMap(screen);
    doCompass(screen);
  }
}
// ------------------------------------------------------------------------------
void fixWinSizes() {
  if(windowWidth>screen.w) windowWidth=screen.w;
  if(windowHeight>screen.h) windowHeight=screen.h;
  if(windowWidth<80) windowWidth=80;
  if(windowHeight<50) windowHeight=50;
  needRedraw=true;
  doubleBuffer.setSize(windowWidth,windowHeight);
}
// ------------------------------------------------------------------------------
void growWindow(int dx, int dy) {
  if(dx && dy) {
    float aspect=(float)windowHeight/windowWidth;
    windowWidth+=dx;
    windowHeight=(int)(windowWidth*aspect);
  }
  else {
    windowWidth+=dx;
    windowHeight+=dy;
  }
  fixWinSizes();
}
// ------------------------------------------------------------------------------
extern bool drawMap; // flag
void Map::drawMap() {
  if(!::drawMap) return;
  byte mapUnknown=0x00, mapFilled=color(0x8f8f8f), mapEmpty=0x00;
  byte * p = picture.buffer;
#define x(a) (a)
#define y(a) (h-(a)-1)
  for(int i=0; i<h; i++)
    for(int j=0; j<w; j++) {
      Cell * c = cell(x(j),y(i));
      if(!c->known) *p++=mapUnknown;
      else if(!c->filled) *p++=mapEmpty;
      else *p++=mapFilled;
    }
  picture.plot(ox,oy,color(0x000000));
  ox=x((int)player->x>>cellFP); oy=y((int)player->y>>cellFP);
  picture.plot(ox,oy,color(0xffffff));
#undef x
#undef y
}
// ---------------------------------------------------------------------------------



